﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace Malovani
{
    public partial class MyArea : UserControl
    {
        private static int cnt = 0;

        public MyArea above = null;

        public List<MyArea> below = new List<MyArea>();

        public Window win = null;
        public TreeNode node = null;
        public MyInfo info = null;

        public MyArea()
        {
            InitializeComponent();

            Name = "my area " + ++ cnt;

            foreach (Control c in this.Controls)
            {
                c.MouseDown += MyArea_MouseDown;
                c.MouseMove += MyArea_MouseMove;
                c.MouseUp += MyArea_MouseUp;
            }
            
        }


        private void MyArea_Load(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
        }

        int X0, Y0;
        bool stisk = false;
        bool resize;

        private void MyArea_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisk = true;
            resize = e.Button == MouseButtons.Right;
        }

        private void MyArea_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
                if (resize)
                {
                    this.Width += e.X - X0;
                    this.Height += e.Y - Y0;
                    X0 = e.X;
                    Y0 = e.Y;
                }
                else
                {
                   this.Left += e.X - X0;
                   this.Top += e.Y - Y0;
                }
            }
        }

        private void MyArea_MouseUp(object sender, MouseEventArgs e)
        {
            stisk = false;
        }

        private void resizeMenu_Click(object sender, EventArgs e)
        {
        }

        static Random r = new Random ();

        private void button1_Click(object sender, EventArgs e)
        {
            MyArea a = new MyArea ();
            
            Color c = Color.FromArgb (64 + r.Next (192),
                                      64 + r.Next (192),
                                      64 + r.Next (192));
            a.BackColor = c;

            a.Left = button1.Left;
            a.Top = button1.Top + 2 * button1.Height;

            win.addArea (this, a);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                BackgroundImage = new Bitmap(openDialog.FileName);
                saveDialog.FileName = openDialog.FileName;
            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (saveDialog.ShowDialog() == DialogResult.OK)
            {
                string s = saveDialog.FileName;
                string t = s.ToLower ();
                // using System.Drawing.Imaging;
                if (t.EndsWith(".bmp"))
                    BackgroundImage.Save(s, ImageFormat.Bmp);
                else if (t.EndsWith(".jpg") || t.EndsWith(".jpeg"))
                    BackgroundImage.Save(s, ImageFormat.Jpeg);
                else
                    BackgroundImage.Save(s); // PNG
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Parent = null;
        }

        private void MyArea_Click(object sender, EventArgs e)
        {
            win.selectArea (this);
        }

        private void MyArea_BackColorChanged(object sender, EventArgs e)
        {
            if (node != null)
               node.BackColor = BackColor;
        }
    }
}
